/*
 * HACK, for a deadline, this ship repeats a single, 2 boned, mesh the given number of times. Saves repeating all those windows. Sorry.
 */

package camp.anchors;

import campskeleton.CampSkeleton;
import java.io.File;
import utils.AbstractDocumentListener;
import utils.SimpleFileChooser;
import utils.WeakListener;

/**
 *
 * @author twak
 */
public class GridMeshUI extends javax.swing.JPanel {

    GridMeshShip ms;
    WeakListener refreshAnchors;

    /** Creates new form MeshShipUI */
    public GridMeshUI()
    {
        initComponents();
    }
    public GridMeshUI(GridMeshShip in, WeakListener refreshAnchors)
    {
        this.refreshAnchors = refreshAnchors;
        this.ms = in;
        initComponents();
        fileField.setText(in.meshFile);
        firstNormalCheckBox.setSelected(in.firstNormalForAll);
        hRepSpinner.setValue(ms.xCount);
        vRepSpinner.setValue(ms.yCount);
        jScrollBar1.setValue((int)ms.dropDown);

        fileField.getDocument().addDocumentListener( new AbstractDocumentListener()
        {
            @Override
            public void changed() {
                try {
                    ms.setMeshFile(fileField.getText());
                } catch (Throwable th) {
                    System.out.println("while trying to cache "+fileField.getText());
                    th.printStackTrace();
                }
                GridMeshUI.this.refreshAnchors.fire();
            }
        });

        scaleSlider.setValue( (int) ( in.scale * scaleSlider.getMaximum()/5 ));
    }

    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        fileField = new javax.swing.JTextField();
        browseButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        scaleSlider = new javax.swing.JScrollBar();
        firstNormalCheckBox = new javax.swing.JCheckBox();
        hRepSpinner = new javax.swing.JSpinner();
        jLabel3 = new javax.swing.JLabel();
        vRepSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        jScrollBar1 = new javax.swing.JScrollBar();
        jLabel5 = new javax.swing.JLabel();

        jLabel1.setText("mesh:");

        fileField.setText("mesh.md5");
        fileField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileFieldActionPerformed(evt);
            }
        });

        browseButton.setText("browse");
        browseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("scale:");

        scaleSlider.setMaximum(1000);
        scaleSlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
        scaleSlider.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                scaleSliderMouseClicked(evt);
            }
        });
        scaleSlider.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                scaleSliderAdjustmentValueChanged(evt);
            }
        });

        firstNormalCheckBox.setText("don't twist");
        firstNormalCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        firstNormalCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                firstNormalCheckBoxActionPerformed(evt);
            }
        });

        hRepSpinner.setValue(1);
        hRepSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                hRepSpinnerStateChanged(evt);
            }
        });

        jLabel3.setText("horz rep");

        vRepSpinner.setValue(1);
        vRepSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                vRepSpinnerStateChanged(evt);
            }
        });

        jLabel4.setText("vert rep");

        jScrollBar1.setMaximum(50);
        jScrollBar1.setMinimum(1);
        jScrollBar1.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
        jScrollBar1.setValue(20);
        jScrollBar1.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBar1AdjustmentValueChanged(evt);
            }
        });

        jLabel5.setText("drop");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(vRepSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(hRepSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(firstNormalCheckBox)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(fileField, javax.swing.GroupLayout.DEFAULT_SIZE, 269, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(browseButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollBar1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)
                            .addComponent(scaleSlider, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE))
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(fileField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1)
                    .addComponent(browseButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(scaleSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(firstNormalCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(hRepSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(vRepSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5)
                    .addComponent(jScrollBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(85, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void browseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtonActionPerformed
        new SimpleFileChooser (CampSkeleton.instance, false, "select mesh") {
            @Override
            public void heresTheFile(File f) throws Throwable {
                fileField.setText( f.getPath() );
                ms.refreshFeatureListener.changed();
            }
        };
    }//GEN-LAST:event_browseButtonActionPerformed

    private void scaleSliderAdjustmentValueChanged(java.awt.event.AdjustmentEvent evt)//GEN-FIRST:event_scaleSliderAdjustmentValueChanged
    {//GEN-HEADEREND:event_scaleSliderAdjustmentValueChanged
        ms.scale = scaleSlider.getValue() * 5. / scaleSlider.getMaximum();
    }//GEN-LAST:event_scaleSliderAdjustmentValueChanged

    private void scaleSliderMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_scaleSliderMouseClicked
    {//GEN-HEADEREND:event_scaleSliderMouseClicked
        if (evt.getClickCount() == 2)
            scaleSlider.setValue(scaleSlider.getMaximum()/5);
    }//GEN-LAST:event_scaleSliderMouseClicked

    private void firstNormalCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_firstNormalCheckBoxActionPerformed
    {//GEN-HEADEREND:event_firstNormalCheckBoxActionPerformed
        ms.firstNormalForAll = firstNormalCheckBox.isSelected();
    }//GEN-LAST:event_firstNormalCheckBoxActionPerformed

    private void fileFieldActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fileFieldActionPerformed
    {//GEN-HEADEREND:event_fileFieldActionPerformed

    }//GEN-LAST:event_fileFieldActionPerformed

    private void hRepSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_hRepSpinnerStateChanged
    {//GEN-HEADEREND:event_hRepSpinnerStateChanged
        ms.xCount = (Integer)hRepSpinner.getValue();
    }//GEN-LAST:event_hRepSpinnerStateChanged

    private void vRepSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_vRepSpinnerStateChanged
    {//GEN-HEADEREND:event_vRepSpinnerStateChanged
        ms.yCount = (Integer)vRepSpinner.getValue();
    }//GEN-LAST:event_vRepSpinnerStateChanged

    private void jScrollBar1AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt)//GEN-FIRST:event_jScrollBar1AdjustmentValueChanged
    {//GEN-HEADEREND:event_jScrollBar1AdjustmentValueChanged
        ms.dropDown = jScrollBar1.getValue();
    }//GEN-LAST:event_jScrollBar1AdjustmentValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browseButton;
    private javax.swing.JTextField fileField;
    private javax.swing.JCheckBox firstNormalCheckBox;
    private javax.swing.JSpinner hRepSpinner;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollBar jScrollBar1;
    private javax.swing.JScrollBar scaleSlider;
    private javax.swing.JSpinner vRepSpinner;
    // End of variables declaration//GEN-END:variables

}
