package straightskeleton.debug;

import straightskeleton.ui.PointEditor;

/**
 *
 * @author twak
 */
public class Main extends javax.swing.JFrame {

    /**
     * -Comments-
     *
     * An intro to the algorithm
     * http://twak.blogspot.com/2009/05/engineering-weighted-straight-skeleton.html
     *
     * Important constants: (chosen for input of size 300-600 units)
     * 
     * EdgeCollision - line 150 - overlap when locating a collision
     * Height Collision - line 55 - criteria for co-sited events
     * CollisionQ - line 105 - criteria for co-heighted events
     *
     * Key classes are:
     *
     * PointEditor - start reading here - pls note the elgance with which the skeleton is executed on the awt thread ;)
     * Skeleton
     * CoSitedCollision
     *
     * Key data elements are:
     * 
     * Edge
     * Corner
     *
     * search for "todo" for areas of dubiousness.
     * note use of linkedHashHap/Set (that eat memory) for deterministic debugging...
     * this has never had a profiler run against it. it might be a good place to start for a speedup.
     *
     */

    /** Creates new form Main */
    public Main() {
//        JOptionPane.showMessageDialog( rootPane, "left drag -> move corners\nshift-click -> remove corner\ncontrol-click on a line -> add corners");
        initComponents();

        WeightedPointEditor pointEditor1 = new WeightedPointEditor();
//        SkeletonPointEditor pointEditor1 = new SkeletonPointEditor();
//        PointEditor pointEditor1 = new PartialOffsetPointEditor();
//        PointEditor pointEditor1 = new OffsetPointEditor();
        setContentPane(pointEditor1);
        pointEditor1.setup();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 686, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 502, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Main().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
